"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var channel_1 = require("./channel");
var Channels = /** @class */ (function () {
    function Channels() {
        this.channels = new Map();
    }
    Channels.prototype.add = function (name, gusher) {
        var channel = this.channels.get(name);
        if (!channel) {
            channel = new channel_1.Channel(name, gusher);
            this.channels.set(name, channel);
        }
        return channel;
    };
    Channels.prototype.all = function () {
        var keys = [];
        this.channels.forEach(function (_, name) {
            keys.push(name);
        });
        return keys;
    };
    Channels.prototype.find = function (name) {
        return this.channels.get(name);
    };
    Channels.prototype.remove = function (name) {
        var channel = this.channels.get(name);
        this.channels.delete(name);
        return channel;
    };
    Channels.prototype.disconnect = function () {
        this.channels.forEach(function (channel) { return channel.disconnect(); });
    };
    return Channels;
}());
exports.Channels = Channels;
