"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function padLeft(input, totalWidth) {
    var str = input.toString();
    return str.length >= totalWidth ? str : padLeft("0" + str, totalWidth);
}
function time() {
    var now = new Date();
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hour = padLeft(now.getHours(), 2);
    var minute = padLeft(now.getMinutes(), 2);
    var second = padLeft(now.getSeconds(), 2);
    var millisecond = now.getMilliseconds();
    return year + "-" + month + "-" + date + " " + hour + ":" + minute + ":" + second + ":" + millisecond;
}
function isDebug() {
    return localStorage.debug === "*" || localStorage.debug === "Gusher";
}
var Logger = /** @class */ (function () {
    function Logger() {
    }
    Logger.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (isDebug()) {
            var params = [];
            params.push("%cGusher %c" + time(), "color: red;", "color: #347deb;");
            console.log.apply(console, params.concat(args));
        }
    };
    return Logger;
}());
exports.default = new Logger();
